#include <avr/io.h>
#include <stdlib.h>


#define F_CPU 8000000UL

#define DDR_DB4 DDRD
#define PORT_DB4 PORTD
#define DB4 PD3

#define DDR_DB5 DDRD
#define PORT_DB5 PORTD
#define DB5 PD4

#define DDR_DB6 DDRD
#define PORT_DB6 PORTD
#define DB6 PD5

#define DDR_DB7 DDRD
#define PORT_DB7 PORTD
#define DB7 PD6


#define DDR_RS DDRD
#define PORT_RS PORTD
#define RS PD1

#define DDR_E DDRD
#define PORT_E PORTD
#define E PD2


#define SET_B1 PORT_B1 |= _BV(B1)
#define CLR_B1 PORT_B1 &= ~_BV(B1)

#define SET_B2 PORT_B2 |= _BV(B2)
#define CLR_B2 PORT_B2 &= ~_BV(B2)

#define SET_B3 PORT_B3 |= _BV(B3)
#define CLR_B3 PORT_B3 &= ~_BV(B3)

#define SET_B4 PORT_B4 |= _BV(B4)
#define CLR_B4 PORT_B4 &= ~_BV(B4)

#define SET_DB4 PORT_DB4 |= _BV(DB4)
#define CLR_DB4 PORT_DB4 &= ~_BV(DB4)

#define SET_DB5 PORT_DB5 |= _BV(DB5)
#define CLR_DB5 PORT_DB5 &= ~_BV(DB5)

#define SET_DB6 PORT_DB6 |= _BV(DB6)
#define CLR_DB6 PORT_DB6 &= ~_BV(DB6)

#define SET_DB7 PORT_DB7 |= _BV(DB7)
#define CLR_DB7 PORT_DB7 &= ~_BV(DB7)

#define SET_E PORT_E |= _BV(E)
#define CLR_E PORT_E &= ~_BV(E)

#define SET_RS PORT_RS |= _BV(RS)
#define CLR_RS PORT_RS &= ~_BV(RS)

#define LCD_X 16
#define LCD_Y 2

unsigned char temperature;
unsigned char temperatura=1;

union {
int tds;
char nds[2];
}ds;

char buf[6]; 



/*void _delay_loop_1(uint8_t __count)
{
	__asm__ volatile (
		"1: dec %0" "\n\t"
		"brne 1b"
		: "=r" (__count)
		: "0" (__count)
	);
}*/

void _delay_loop_2(uint16_t __count)
{
	__asm__ volatile (
	"1: sbiw %0,1" "\n\t"
	"brne 1b"
	: "=w" (__count)
	: "0" (__count)
	);
}

static __inline__ void _delay_ms(double __ms)
{
	uint16_t __ticks;
	double __tmp = ((F_CPU) / 4e3) * __ms;
	if (__tmp < 1.0)
		__ticks = 1;
	else if (__tmp > 65535)
		__ticks = 0;
	else
		__ticks = (uint16_t)__tmp;
		_delay_loop_2(__ticks);
}




void out_nibble(char x)
{
	CLR_DB4;
	CLR_DB5;
	CLR_DB6;
	CLR_DB7;
	if(x & _BV(0)) SET_DB4;
	if(x & _BV(1)) SET_DB5;
	if(x & _BV(2)) SET_DB6;
	if(x & _BV(3)) SET_DB7;
}


void write_to_lcd(char x)
{
	SET_E;
	out_nibble(x >> 4);
	CLR_E;
	SET_E;
	out_nibble(x);
	CLR_E;
	_delay_ms(1);
	
	//delay_ms(1);
}

void write_command(char x)
{
	CLR_RS;
	write_to_lcd(x);
}

void write_char(char x)
{
	SET_RS;
	write_to_lcd(x);
}

void write_text(char * s)
{
	while(*s)
	{
		write_char(*s);
		s++;
	}
}

void lcd_init(void)
{
	DDR_DB4 |= _BV(DB4);
	DDR_DB5 |= _BV(DB5);
	DDR_DB6 |= _BV(DB6);
	DDR_DB7 |= _BV(DB7);
	DDR_E |= _BV(E);
	DDR_RS |= _BV(RS);

	//delay_ms(15);
	_delay_ms(15);
	CLR_E;
	CLR_RS;
	char i;
	for(i = 0; i < 3; i++)
	{
		SET_E;
		out_nibble(0x03);
		CLR_E;
	_delay_ms(5);
	//delay_ms(5);
	}
	SET_E;
	out_nibble(0x02);
	CLR_E;
	_delay_ms(1);
	//delay_ms(1);
	write_command(0x28); // interfejs 4-bity, 2-linie, znak 5x7
	write_command(0x08); // wycz LCD, kursor i miganie
	write_command(0x01); // czy LCD
	write_command(0x06); // bez przesuwania w prawo
	write_command(0x0C); // wcz LCD, bez kursora i mrugania
}


void LCD_xy(uint8_t x, uint8_t y)
{
	switch(y)
	{
		case 1: y=0x40; break;
		case 2: y=0x14; break;
	}
	write_command(0x80+y+x);
}

void LCD_clr(void)
{
	write_command(0x01);
	_delay_ms(1);
	//delay_ms(1);
	LCD_xy(0,0);
}
/*
void _delay_us(double __us)
{
	uint8_t __ticks;
	double __tmp = ((F_CPU) / 3e6) * __us;
	if (__tmp < 1.0)
		__ticks = 1;
	else if (__tmp > 255)
		__ticks = 0;	//i.e. 256 
	else
		__ticks = (uint8_t)__tmp;
	_delay_loop_1(__ticks);
}



void delay(unsigned int t)
{
	do
	{
		asm("nop");
	}
	while(--t);


}*/

void delay(int useconds)
{
int s;
useconds = useconds;
for (s=0; s<useconds;s++);
}

unsigned char ow_reset(void) // reset lini one wire
{
	unsigned char presence=1;
	DDRB |= _BV(0); //DQ = 0; //pull DQ line
	//PORTB &= ~_BV(0);
	delay(960);
	DDRB &= ~_BV(0); //DQ = 1; // allow line to //powrt lini 1w do trybu wejcia
	//PORTB |= _BV(0);
	delay(144);// wait for presence pulse(pochodzcy od DS-a) //czekamy na ustabilizowanie lini
	if(bit_is_clear(PINB,0)) presence=0; //odczytujemy co wystawi na lini DS
	delay(880);// wait for end
	return(presence); // presence signal
} // 0=presence, 1 = no part

///---------------------------------------------------------

// READ_BIT - reads a bit from the one-wire bus. The delay
// required for a read is 15us, so the DELAY routine won't work.
// We put our own delay function in this routine in the form of a
// for() loop.
unsigned char read_bit(void)
{
	unsigned char presence=0;
	DDRB |= _BV(0); 	//DQ = 0; // pull DQ low to start timeslot
	DDRB &= ~_BV(0);	//DQ = 1; // then return high
	delay(30); // delay 15us from start of timeslot
	if(bit_is_clear(PINB,0)) presence=0;
	if(bit_is_set(PINB,0)) presence=1;
	return(presence); // return value of DQ line
}
///---------------------------------------------------------

void write_bit(char bitval) //WRITE_BIT - writes a bit to the one-wire bus, passed in bitval.
{
	DDRB |= _BV(0); //DQ = 0; // pull DQ low to start timeslot
	if(bitval==1) DDRB &= ~_BV(0); //DQ =1; // return DQ high if write 1
	delay(204); // hold value for remainder of timeslot - delay 104us
	DDRB &= ~_BV(0);//DQ = 1;
}

///---------------------------------------------------------

unsigned char read_byte(void) // READ_BYTE - reads a byte from the one-wire bus
{
	unsigned char i;
	unsigned char value = 0;
	for (i=0;i<8;i++)
	{
		if(read_bit()) value|=0x01<<i; // reads byte in, one byte at a time and then
		delay(240); // ??shifts it left wait for rest of timeslot 120us
	}
	return(value);
}

///---------------------------------------------------------

void write_byte(char val) // WRITE_BYTE - writes a byte to the one-wire bus.
{
	unsigned char i;
	unsigned char temp;
	for (i=0; i<8; i++) // writes byte, one bit at a time
	{
		temp = val>>i; // shifts val right 'i' spaces
		temp &= 0x01; // copy that bit to temp
		write_bit(temp); // write bit in temp into
	}
	delay(204);

}

///---------------------------------------------------------

void Read_Temperature(void)
{
	char tmp[10];
	char temp_lsbyte,temp_msbyte;
	char buffer[4]="    ";
	int k,i;

	
	
	if(ow_reset()) {LCD_xy(0,0); write_text("cisza");}
	else
	{
		write_byte(0xCC); //Skip ROM
		write_byte(0x44); // Start Conversion
		
		_delay_ms(1000);
		_delay_ms(1000);
		_delay_ms(1000);
		ow_reset();
		write_byte(0xCC); // Skip ROM
		write_byte(0xBE); // Read Scratch Pad
		LCD_clr();
		ds.nds[0]=read_byte();
   		ds.nds[1]=read_byte();
   		itoa(ds.tds/2,buf,10);//temper. cakowita
   		write_text("Temp: ");
		write_text(buf);
		write_text(".\0");
   		itoa(abs((ds.tds*10/16)%10),buf,10);	//czci dziesitne
   		write_text(buf);
		write_text(" C");
				

		
}
} 

int main (void)

{	
	char i=0;
	lcd_init();
	LCD_clr();
	DDRB=0x00;
	PORTB=0x00;
//	DDRC=0xff;
/*int kontrola;
kontrola=ow_reset();

	if (kontrola==1) {write_text("Jest Czujnik !");}
	//else if (kontrola==1) {write_text("Brak Czujnika !");}
	for(i=0;i<30;i++){			//Tworzy opnienie do odwieania temp
		_delay_loop_2(65535);
		}*/

	while(1){
	i=0;
	Read_Temperature();

	for(i=0;i<30;i++){			//Tworzy opnienie do odwieania temp
		_delay_loop_2(65535);

	}
	//ow_reset();

	LCD_xy(0,1);
	}
	return(0);
        
}
