//program zegara czasu rzeczywistego, pomiar: godzin, minut, dnia, miesiace, roku
//The real time counter, hours, minutes, days, months, years
//aktywne dwa klawisze podlaczne do portu D (PD.2, PD.1), two buttons should be connected to port B (PB.2, PB.1)
//PB(5-0) podlaczone do LCD (zamkniete zworki LCD); PB(5-0) connected to LCD (closed LCD jumpers)
//pin SDA ze zlacza RTC podlaczony do PD.3, pin SCL do PD.4; SDA pin from RTC header connected to PB.3, SCL pin connected to PB.4

 #include <avr\io.h>
 #include <avr\delay.h>
 #include <avr\interrupt.h>
 #include <compat\ina90.h>
 #include <stdio.h>
 #include <math.h>
 #include <stdlib.h>
 #include "keyboard.h"
#include <avr\interrupt.h>
#include <compat\ina90.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "keyboard.c" 



void send_iic(unsigned char data_iic,const char start,const char stop);
unsigned char rec_iic(const char start,const char stop);
void send_lcd(unsigned char data_lcd,unsigned char cmd); 
//void delay(volatile int del);
unsigned char hexdec_plus(unsigned char inhex);  
void printLCD(unsigned char licz_znak,unsigned char pozycja_migania);  
void format(void);
 
const char ilosc_znakow = 0x05; 
const char dat_lcd = 0x01;
const char cmd_lcd = 0x00;
const char data = 0x08;
const char clk = 0x10;
 
unsigned char znaki[11];  //[ilosc_znakow+6]
unsigned char znaki_lcd[13];  //[ilosc_znakow*2+3]
unsigned char znaki_lcd_1[18];  //[ilosc_znakow*3+3]
unsigned char miganie;

void delay(volatile unsigned int d)
	{
    _delay_loop_2(d);
	}
	                
void main(void)
{
 char ack;
 unsigned char key=0x07,znak_key; 
 unsigned char temp,lcd_znak,pozycja_migania=0; 
 
 sei();
	//do klawiszy
	KL_INIT;
	TCCR0 = 1<<CS02 |0<<CS01 |0<<CS00;    //ustawienie licznika na CK/256 
	TIMSK = 0<<TOIE1 |0<<OCIE1A |0<<OCIE1B |0<<TICIE1 |1<<TOIE0;   
 
  DDRB = 0xff;	// PORTB: output
  //PAOR = 0xff;	   
  
  DDRD = 0x00;	// PORTD: input
  //PBOR = 0x00;	  
                                   //inicjacja LCD; LCD initiate
   delay(3000);
   delay(3000);   
   send_lcd(0x28,cmd_lcd);			//2 linie, 4 bity; 2 lines, 4 bits 
   delay(1000);   
   send_lcd(0x0C,cmd_lcd);			//wlacz LCD, wlacz kursor; LCD on, cursor on
   delay(1000);      
   send_lcd(0x06,cmd_lcd);			//przesuwanie kursora w prawo; cursor inc., 
   delay(1000);   
   send_lcd(0x01,cmd_lcd);			//wyczysc LCD; clr LCD 
   delay(1000);   
   send_lcd(0x02,cmd_lcd);			//cursor home, 
   delay(1000);  
           
  /*start zegarek*/  
  for(temp=0;temp<7;temp++)
  {
   send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0, address rtc to write - address 0xD0
   send_iic(temp,0x00,0x00);   //wybierz temp adres w rtc 0x00, choose temp address in rtc 0x00    
   send_iic(0x00,0x00,0x01);   //wyslij dana do rtc pod adres 0x00, start, stop; send data to rtc at memory location 0x00, start, stop  
  }
                   
 while(1){
   switch(key)
   {
    case KL_3: 					//przesuwanie, shift position
  if(znak_key == 0x00)   
  { 
   if(pozycja_migania >= 3*ilosc_znakow){pozycja_migania = 0x00;}else{pozycja_migania += 3;}
   znak_key = 0x01;
  } 
     break;

    case KL_4:					//zwiekszanie wartosci, increment
  if(znak_key == 0x00)   
  {                    
   znaki[pozycja_migania/3]++;
   lcd_znak = znaki[pozycja_migania/3];          
   lcd_znak=hexdec_plus(lcd_znak);
   znaki[pozycja_migania/3]=lcd_znak;   
   
   if(pozycja_migania/3==0)
   {  
    if(lcd_znak == 0x24){lcd_znak=0;}  //godziny; hours
    send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0; start, address rtc to write, address 0xD0
    send_iic(0x02,0x00,0x00);   //wybierz 0x02 adres w rtc; choose 0x02 address at rtc
    send_iic(lcd_znak,0x00,0x01);   //wyslij dana do rtc pod adres 0x02, stop; send data to rtc at 0x02 address, stop  
   } 
   
   if(pozycja_migania/3==1)
   { 
    if(lcd_znak == 0x60){lcd_znak=0;}    //minuty; minutes
    send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0; start, address rtc to write, address 0xD0
    send_iic(0x01,0x00,0x00);   //wybierz 0x01 adres w rtc; choose 0x01 address at rtc  
    send_iic(lcd_znak,0x00,0x01);   //wyslij dana do rtc pod adres 0x01, stop; send data to rtc at 0x01 address, stop  
   }   

   if(pozycja_migania/3==2)
   { 
    if(lcd_znak == 0x32){lcd_znak=0x01;}      //dzien; day
    send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0; start, address rtc to write, address 0xD0
    send_iic(0x04,0x00,0x00);   //wybierz 0x04 adres w rtc; choose 0x04 address at rtc  
    send_iic(lcd_znak,0x00,0x01);   //wyslij dana do rtc pod adres 0x01, stop; send data to rtc at 0x01 address, stop  
   }   

   if(pozycja_migania/3==3)
   { 
    if(lcd_znak == 0x13){lcd_znak=0x01;}     //miesiac; month
    send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0; start, address rtc to write, address 0xD0
    send_iic(0x05,0x00,0x00);   //wybierz 0x05 adres w rtc; choose 0x05 address at rtc  
    send_iic(lcd_znak,0x00,0x01);   //wyslij dana do rtc pod adres 0x01, stop; send data to rtc at 0x01 address, stop   
   } 
   
   if(pozycja_migania/3==4)            //rok; year
   {    
    send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0, start, address rtc to write, address 0xD0
    send_iic(0x06,0x00,0x00);   //wybierz 0x06 adres w rtc; choose 0x06 address at rtc  
    send_iic(lcd_znak,0x00,0x01);   //wyslij dana do rtc pod adres 0x01, stop; send data to rtc at 0x01 address, stop 
   }          
   znak_key = 0x01;           
  }                     
   break;
    

   
   default:
    znak_key = 0x00;
   break;   
                          
   }      
     key = PORTD & 0x07;  
     
 for(temp=1;temp<0x07;temp++)
 {
   send_iic(0xD0,0x01,0x00);   //start,adresuj rtc do zapisu adres 0xD0, start, address rtc to write, address 0xD0
   send_iic(temp,0x00,0x00);   //wybierz temp adres w rtc; choose temp address at rtc 
   send_iic(0xD1,0x01,0x00);   //start,adresuj rtc do odczytu adres 0xD0; start, address rtc to read, address 0xD0
   znaki[temp+0x06]= rec_iic(0x00,0x00); //odczytaj z adresu temp, read from temp addres  
 }
                
   znaki[1]=znaki[1+6];        
   znaki[0]=znaki[2+6];
   znaki[2]=znaki[4+6];
   znaki[3]=znaki[5+6];        
   znaki[4]=znaki[6+6];
    
   for(temp=0;temp<5;temp++)                  
   {
    znaki_lcd[2*temp]=(((znaki[temp] & 0xF0) >> 4) | 0x30);
    znaki_lcd[2*temp+1]=((znaki[temp] & 0x0F) | 0x30);       
   }             
     format(); 
     printLCD((3*ilosc_znakow) - 1,pozycja_migania); 
     miganie++;     
   }	//end while loop 
}	//end main



 
void send_iic(unsigned char data_iic,const char start,const char stop)  //nadawanie po szynie iic,
{    																		// transmission on the iic
unsigned char count;
volatile unsigned char temp;
unsigned char maska=0x80;  	//maska do wysylania 'data_iic' bit po bicie; mask used to sending 'data_iic' bit by bit

 DDRD = data | clk;			//PB3, PB4 - wyjcia; PB3, PB4 - outputs			
 //PBOR = 0x00;					//open-drain
 					
if(start != 0x00)			
{									//start transmisji; transmssion start
 PORTD = ((PORTD | clk) | data);		//SDA i SCL =1; SDA and SCL =1
 PORTD = PORTD & (~data);   			//SDA=0	
}
for(count=0;count<8;count++)		//wysylanie 8 bitow danych; sending 8 bits of data
 {                              
   PORTD = PORTD & (~clk);               					//SCL=0
   if((data_iic & maska)!=0) {PORTD = ((PORTD | data) & (~clk));} 		//wyslij jeden bit danych (jesli SDA=1); send one bit of data (if SDA=1)
   else {PORTD = ((PORTD & (~data)) & (~clk));}                        	//wyslij jeden bit danych (jesli SDA=0);send one bit of data (if SDA=0)
   maska = (maska >> 1);     							//przesun maske w prawo; shift right mask
   PORTD = PORTD | clk;                  					//SCL=1
   PORTD = PORTD & (~clk);               				//SCL=0
 }     
          
   PORTD = clk;						// SDA: wejscie,SCL: wyjscie; SDA: input,SCL: out
    
   PORTD = PORTD & (~clk);                                //SCL=0  
   PORTD = PORTD | clk;                                   //SCL=1       
   PORTD = PORTD & (~clk);                                //SCL=0 

   DDRD = clk | data;					// SDA,SCL: wyjscie; SDA,SCL: out
                  
   if(stop != 0x00) 					//stop
    {           
     PORTD = PORTD | clk;                                 //SCL=1 
     PORTD = PORTD & (~data);                             //SDA=0
     PORTD = PORTD | data;                                //SDA=1     
    }                                                                              
} 


unsigned char rec_iic(const char start,const char stop) // odbior po szynie iic; receieve on the iic
{    													
unsigned char count,ack;
unsigned char data_iic;
unsigned char maska=0x80;				//maska do odbioru 'data_iic' bit po bicie; mask used to receive 'data_iic' bit by bit

 DDRD = clk | data;					//SDA,SCL: wyjscia; SDA,SCL: output
 //PBOR = 0x00;							//open-drain
 							
if(start != 0x00)						//start 
{
 PORTD = ((PORTD | clk) | data);			//SDA i SCL =1; SDA and SCL =1
 PORTD = PORTD & (~data);   				//SDA=0
}

 DDRD = clk;					        //SCL: wyjscie; SCL: output

for(count=0;count<8;count++)			//odbieranie 8 bitow danych; receiv 8 bits of data
 {                              
   PORTD = PORTD & (~clk);               			//SCL=0
   if((PORTD & data)!=0) {data_iic = data_iic | maska;} 	//zapisz jeden bit danych (jeli SDA=1); save one bit of data (if SDA=1)
   else {data_iic = data_iic & (~maska);}       	//zapisz jeden bit danych (jesli SDA=0); save one bit of data (if SDA=0)  
   maska = (maska >> 1);							//przesun maske w prawo; shift right mask
   PORTD = PORTD | clk;                  			//SCL=1
   PORTD = PORTD & (~clk);               			//SCL=0
 }              
                                                                       
   PORTD = PORTD & (~clk);                                //SCL=0  
   PORTD = PORTD | clk;                                   //SCL=1
   ack =  PORTD & data;									//odczytaj potwierdzenie; read acknowledge
   PORTD = PORTD & (~clk);                                //SCL=0 
                  
   if(ack != 0x00 | stop != 0x00) 
    {           
     PORTD = PORTD | clk;                                 //SCL=1 
     PORTD = PORTD & (~data);                             //SDA=0
     PORTD = PORTD | data;                                //SDA=1     
    }                                                   //stop 
                     
  return data_iic;     
}                      

  void send_lcd(unsigned char data_lcd,unsigned char cmd) // obsluga LCD; LCD operatons
  {
    PORTB = ((((data_lcd >> 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0
    PORTB = ((((data_lcd >> 2) & 0xFE) | cmd) | 0x02);    //RS=1/0, E=1
    PORTB = ((((data_lcd >> 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0
    
    PORTB = ((((data_lcd << 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0
    PORTB = ((((data_lcd << 2) & 0xFE) | cmd) | 0x02);    //RS=1/0, E=1
    PORTB = ((((data_lcd << 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0    
   }           
  

  // void delay(volatile int del)		//funkcja opozniajaca; delay function
  //{
   //for(;del>0;del--)
   //{
   // ;
   //}
  //}


	  
unsigned char hexdec_plus(unsigned char inhex) //zamiana formatu hex na dec
{													//change from hex to dec
if((0x0F & inhex) >= 0x0a)
 { 
  inhex = (inhex & 0xF0);
  inhex += 0x10; 
 }              
 if((0xF0 & inhex) >= 0xa0)
  { 
   inhex = (inhex & 0x0F);
  }                    
  return inhex;
}
               
void printLCD(unsigned char licz_znak,unsigned char pozycja_migania)  // wyswietlaj na LCD i migaj na "pozycja_migania"
{    																	//display and switch 
unsigned char temp,ilosc_znakow;
send_lcd(0x02,cmd_lcd);			 			//cursor home
delay(300);
for(ilosc_znakow = 0; ilosc_znakow < licz_znak; ilosc_znakow++)
 {         
  if(((ilosc_znakow==pozycja_migania) || (ilosc_znakow==pozycja_migania+1)) && ((miganie & 0x08) == 0x08))
  {  
   send_lcd(' ',dat_lcd);   
  }
  else{
       temp=znaki_lcd_1[ilosc_znakow];      
       send_lcd(temp,dat_lcd);
      }
  delay(300);                
 }                
}                         
     
void format(void) // formatuj dane do wyswietlania na LCD, prepare data to be displayed
{    
unsigned char i,j,k=0;
for(i=0;i<ilosc_znakow;i++)
{
 for(j=0;j<2;j++)
 {
  znaki_lcd_1[j+2*i+k]=znaki_lcd[j+2*i];
 }                        
  if((j+2*i+k)==0x05){znaki_lcd_1[j+2*i+k]=' ';}  else{znaki_lcd_1[j+2*i+k]=0x3A;}
 k++;
}
}
