//pomiar temperatury w calkowitych wartosciach stopni cels.
//measure of temperature
//wejscie przetwornika A/C na PC.3, PORTC.3 connected to LM35     PLLx4
 #include <avr\io.h>
 #include <avr\delay.h>
 #include <avr\interrupt.h>
 #include <compat\ina90.h>
 #include <stdio.h>
 #include <math.h>
 #include <stdlib.h>

 
  
  void send_lcd(unsigned char data,unsigned char cmd);  
  void delay(int del);
  void init_LCD(void);
  unsigned char adc_convert(void);    
  
  const char dat_lcd = 0x01; //dana dla LCD, data for the LCD
  const char cmd_lcd = 0x00; //komenda dla LCD, command for the LCD
  
  //const int stala = 9000; // stala kalibrujaca termometr; calibration constant            
  const int sredn_const = 64; // stala kalibrujaca termometr; calibration constant 
  
  //stala - ustala przesuniecie wskazan termometru w funkcji temperatury, constans for adjustment the thermometer 
  // sredn_const - ustala szybkosc przyrostu wskazan termometru w funkcji temperatury, constans for adjustment the thermometer
  
  void main(void)
  {  
   
   unsigned int temp,dzies,jedn;
   unsigned char temp_H,temp_L,sredn;
   
   DDRD = 0xFF;	// PORTD: bits 0..7 output
   //PAOR = 0xFF;		// push-pull 
   DDRC=0x00;          //PORTC: inputs
   //PBOR=0x00;           //floating
   
   init_LCD(); 				//inicjacja LCD; LCD initiate
     
   send_lcd('T',dat_lcd); 	//wysylanie napisu "TEMP=" na LCD; send "TEMP=" on LCD
   delay(300);
   send_lcd('E',dat_lcd);
   delay(300);   
   send_lcd('M',dat_lcd);
   delay(300);   
   send_lcd('P',dat_lcd);          			
   delay(300);           
   send_lcd('=',dat_lcd);          			
   delay(300);      
   
      
   while(1) 
   {   
    temp=0;      
    for(sredn=0;sredn<sredn_const;sredn++)    //pomiar napiecia; voltage measurin 
    {   
     temp += (unsigned int)adc_convert(); 	//suma wynikw; sum of all results
    }
      
	//temp += stala;					//dodanie stalej; add constant

    dzies = temp%16;
	dzies = temp/10;	// 000 starsza cyfra wyniku; most important digit of result
	

    //jedn = temp%10;	//000
    //jedn = jedn/100;     //00 mlodsza czyfra wyniku; less important digit of result 	  
	
	//dzies=((2.56)/(256*temp*100));
    send_lcd(0x85,cmd_lcd);			//ustawia kursor na pozycji 6 w linii 1; set cursor on position 6 in 1 line 
    delay(100);                 
    send_lcd((dzies & 0x0f) | 0x30,dat_lcd);	//wyprowadz na LCD starsza cyfre wyniku; send to LCD most important digit of result
    delay(100);			         
    //send_lcd((jedn & 0x0f) | 0x30,dat_lcd);	//wyprowadz na LCD mlodsza cyfre wyniku; send to LCD less important digit of result		
    //delay(100);
    send_lcd(0xDF,dat_lcd);          			//wyswietl symbol stopni; print degree symbol
    delay(100); 
    send_lcd('C',dat_lcd);          			//wyswietl "C"; print "C"
    delay(100);             
   }                       
  }   
  
  void send_lcd(unsigned char data_lcd,unsigned char cmd)		// obsluga LCD; LCD operatons
  {
    PORTD = ((((data_lcd >> 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0
    PORTD = ((((data_lcd >> 2) & 0xFE) | cmd) | 0x02);    //RS=1/0, E=1
    PORTD = ((((data_lcd >> 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0
    
    PORTD = ((((data_lcd << 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0
    PORTD = ((((data_lcd << 2) & 0xFE) | cmd) | 0x02);    //RS=1/0, E=1
    PORTD = ((((data_lcd << 2) & 0xFE) | cmd) & 0xFD);    //RS=1/0, E=0    
   } 
     
  void delay(volatile int del)		//funkcja opozniajaca; delay function
  {
   for(;del>0;del--)
   {
    ;
   }
  }    
  
  unsigned char adc_convert(void)		//konwersja analogowo-cyfrowa; analog to digital conversion  
  {                          
   //ADCAMP = 0x0C;  						//fcpu/4 dla ADC, wzmocnienie x*8: fcpu/4 to ADC, amplifier is selected (x8)
   //ADCCSR = ADCCSR | 0x23;       			//wczenie przetwornika, kana AIN3; ADC ON, channel AIN3
   
   ADMUX=0x63;
	ADCSRA=0xC2;	

   while(!(ADCSRA & 0x10))  			//oczekiwanie na zakonczenie konwersj; waiting on convesion end
   {;}
   return ADCH ;      //wynik: 8 najstarszych bitw; result: 8 most importand bits
  }  
  
  
 
    
       
  void init_LCD(void)			//inicjacja LCD; LCD initiate
  {
   delay(3000);
   delay(3000);   
   send_lcd(0x28,cmd_lcd);			//2 linie, 4 bity; 2 lines, 4 bits 
   delay(1000);   
   send_lcd(0x0C,cmd_lcd);			//wlacz LCD, wlacz kursor; LCD on, cursor on
   delay(1000);      
   send_lcd(0x06,cmd_lcd);			//przesuwanie kursora w prawo; cursor inc., 
   delay(1000);   
   send_lcd(0x01,cmd_lcd);			//wyczysc LCD; clr LCD 
   delay(1000);   
   send_lcd(0x02,cmd_lcd);			//cursor home, 
   delay(1000); 
  }
  
