// Adamowicz Piotr, PROPOX
/*Demo wyswietlacza - ruchomy napis EVBAVR-03,The demo of the LCD - a moving caption*/
  /*All jumpers associated with the LCD shoudl be connected with jumpers of the PORTD */
// PDO - R/S
// PD1 - E
// PD2 - D4
// PD3 - D5
// PD4 - D6
// PD5 - D7
//
 #include <avr\io.h>
 #include <avr\delay.h>
 #include <avr\interrupt.h>
 #include <compat\ina90.h>
 #include <stdio.h>
 #include <math.h>
 #include <stdlib.h>

void printlcd(const char *s);
void writehex(int hexval);
void send_lcd_data(unsigned char data);  // wyslij dana do LCD, send data to the LCD
void send_lcd_reg(unsigned char data);  // wyslij dana do LCD, send data to the LCD
void delay(volatile unsigned int d);			//funkcja opunienia; delay function
void init_LCD(void);			//inicjalizacja LCD; LCD initiation


unsigned int licznik = 0;


  int main(void)
  {
 	DDRD = 0xFF;	// PORTD: bity 0..7 -wyjcia; PORTD: bits 0..7 - outputs
	DDRB = 0x00;
	PORTB = 0xff;
	init_LCD();  //inicjalizuj LCD, initiate of the LCD

	while(1)
	{
		send_lcd_reg(0x80);
		printlcd("licznik=");
		writehex(licznik);

		while(!(PINB & 0x01));
		delay(10000);
		if((PINB & 0x01)) licznik++;
		while((PINB & 0x01));
		delay(10000);

	}	
	
  }



  void send_lcd_data(unsigned char data_lcd)		//funkcja wywania danych do LCD; LCD data sending function
  {
    PORTD = ((data_lcd >> 2)& 0xfc) | 0x01;    //RS=1, E=0
    //delay(200);
    PORTD = ((data_lcd >> 2)& 0xfc) | 0x03;    //RS=1, E=1
    //delay(200);
    PORTD = ((data_lcd >> 2)& 0xfc) | 0x01;    //RS=1, E=0
    //delay(200);

    PORTD = ((data_lcd << 2)& 0xFC) | 0x01;    //RS=1, E=0
    //delay(200);
    PORTD = ((data_lcd << 2)& 0xfc) | 0x03;    //RS=1, E=1
    //delay(200);
    PORTD = ((data_lcd << 2)& 0xfc) | 0x01;    //RS=1, E=0
    delay(1000);
   }

 void send_lcd_reg(unsigned char data_lcd)		//funkcja wywania komend do LCD; LCD command sending function
  {
    PORTD = ((data_lcd >> 2) & 0xFC);    //RS=0, E=0
    //delay(200);
    PORTD = ((data_lcd >> 2) & 0xFC)| 0x02;    //RS=0, E=1
    //delay(200);
    PORTD = ((data_lcd >> 2) & 0xFC);    //RS=0, E=0
    //delay(200);

    PORTD = ((data_lcd << 2) & 0xFC);    //RS=0, E=0
    //delay(200);
    PORTD = ((data_lcd << 2) & 0xFC) | 0x02;    //RS=0, E=1
    //delay(200);
    PORTD = ((data_lcd << 2) & 0xFC);    //RS=0, E=0
    delay(10000);
   }


 void delay(volatile unsigned int d)
	{
    _delay_loop_2(d);
	}


  void init_LCD(void)			//funkcja inicjacji LCD; LCD initiate function
  {
   delay(30000);
   delay(30000);
  //send_lcd_reg(0x28);			//2 linie, 4 bity  ,2 lines, 4 bits
   //delay(100);
   send_lcd_reg(0x28);
   delay(1000);
   send_lcd_reg(0x0C);			//wlacz LCD, wlacz kursor; LCD on, cursor on
   delay(10000);
   send_lcd_reg(0x06);			///przesuwanie kursora w prawo; cursor inc.,
   delay(10000);
   send_lcd_reg(0x01);			//wyczysc LCD; clr LCD
   delay(10000);
   send_lcd_reg(0x02);			//cursor home,
   //delay(30000);
   delay(30000);
  }

  void putcharlcd(char c)
{
	send_lcd_data(c);
}

void printlcd(const char *s)
{
	while(*s) putcharlcd(*s++);
}

void writehex(int hexval)
{
  char i;

  int temp;

  char val;

  putcharlcd('0');
  putcharlcd('x');

  temp=hexval;

  for(i=0;i<4;i++)
  {
    val=(temp&0xF000)>>12;
    if (val<=9)
	{
      putcharlcd(val+0x30);
    } else
	{
      putcharlcd(val+0x41-0xA);
    }
    temp=(temp<<4);
  }
}

