#include <avr\io.h>
//#include <avr/iom128.h>
#include <avr\signal.h>
#include <avr\interrupt.h>
//#include <avr/eeprom.h>
//#include <avr/wdt.h>
#include <avr\pgmspace.h>

#include "keyboard.h"
//#include "ekrany.h"
//#include "defs.h"
#define PB1 1


//unsigned char kl_del=0;
volatile unsigned char key=0x00;              //informuje o wcisnieci klawisza
volatile unsigned char key_pressed=0x00;      //przechowuje wartosc klawisza
enum {WAITING, PUSHING, KEEPING, RELEASEING};  //definicja wartosci wyliczeniowych



INTERRUPT(SIG_OVERFLOW0)                     //przerwanie przepelnienia licznika T0
{
  static unsigned char state = WAITING;     //zmienna dla stanow klawiszy
  unsigned char klawisz=0x00;               //tymczasowa wartosc klawisza w danym cyklu przerwania
  static unsigned char prev_key=0x00;       //przechowuje wartosc poprzedniego klawisza
  
  	
//pobieranie klawiszy
if (!(PINB &(0x02)))						// przypisanie klawiszy
	{
	klawisz=KL_1;
	}
else if (!(PINB &(0x04)))						// przypisanie klawiszy
	{
	klawisz=KL_2;
	}
else if (!(PINB &(0x08)))						// przypisanie klawiszy
	{
	klawisz=KL_3;
	}
else if (!(PINB &(0x10)))						// przypisanie klawiszy
	{
	klawisz=KL_4;
	}
else klawisz=0;
//koniec pobierania klawiszy	  

  switch(state)                            //przelacz stan klawiszy w zaleznoci od wartosci (eliminacja drgan klawiszy)
    {
        case WAITING:
        {
            if(klawisz)    // jesli krorykolwiek klawisz wcisniety
            {
                prev_key = klawisz;    //zapisz do wartosci poprzedniej (potrzebna dla zprawdzenia klawisza w kolejnym cyklu przerwania)
                state = PUSHING;       //zmien stan
            }
            key_pressed = 0x00;
            break;
        }
        case PUSHING:         
        {
            if(prev_key==klawisz)         //jesli klawisz = klawiszowi poprzednio zapisanemu
            {
                key = prev_key;           //zapisz wartosc klawisza do zmiennej globalnej 'key'
                state = KEEPING;          //zmieni stan
            }
            else
			{
			state = WAITING;   //jesli nierowny to wroc do stanu poprzedniego
			prev_key=0x00;          //wyczysc wartosc poprzednia klawisza
            key_pressed=0x00;
            }
        	break;
        }
        case KEEPING:                               
        {
            if(prev_key==klawisz)  {}//key= prev_key;    //klawisz caly czas wcisniety, trzymaj wartosc klawisza
            else state = RELEASEING;                 //jesli sie znienil to zmien stan 
            key_pressed=klawisz;
            break;
        }
        case RELEASEING:
        {
            if(prev_key!=klawisz)               //jesli zmiana klawisza
            {
		 	    key_pressed = 0;//klawisz;             //sygnalizuj gotowosc klawisza do obslugi
                state = WAITING;                // wroc do poczatku obslugi klawiszy
                prev_key=0x00;                  //wyczysc wartosc poprzednia klawisza
            }
            else state = KEEPING;             //jesli nie ma zmiany wartosci klawisza to wroc do stanu poprzedniego
            break;
        }
        default:
        {
            state = WAITING;
            break;
        }
    } 
 // }
}

