/*Demo wyswietlacza - ruchomy napis EVBAVR-04,The demo of the LCD - a moving caption*/
  /*All jumpers associated with the LCD shoudl be connected with jumpers of the PORTD */
// PDO - R/S
// PD1 - E
// PD2 - D4
// PD3 - D5
// PD4 - D6
// PD5 - D7
//
 #include <avr\io.h>
 #include <avr\delay.h>
 #include <avr\interrupt.h>
 #include <compat\ina90.h>
 #include <stdio.h>
 #include <math.h>
 #include <stdlib.h>


  void send_lcd_data(unsigned char data);  // wyslij dana do LCD, send data to the LCD
  void send_lcd_reg(unsigned char data);  // wyslij dana do LCD, send data to the LCD
  void delay(volatile unsigned int d);			//funkcja opunienia; delay function
  void init_LCD(void);			//inicjalizacja LCD; LCD initiation
  const char dat_lcd = 0x01; //dana dla LCD, data for the LCD
  const char cmd_lcd = 0x00; //komenda dla LCD, command for the LCD
  const char text[]={' ','E','V','B','A','V','R','-','0','4'};//tablica znakw dla grnej linii LCD; characters array for top LCD line
  const char text2[]={'P','R','O','P','O','X','-','2','0','0','6'};	//tablica znakw dla dolnej linii LCD; characters array for bottom LCD line
  void main(void)
  {
   unsigned char adr=0; //pozycja napisu na wyswietlaczu, position of characters on the LCD
   unsigned char znak;  //znak do wyswietlenia, character to be displayed

   int licznik=0;

   DDRD = 0xFF;	// PORTD: bity 0..7 -wyjcia; PORTD: bits 0..7 - outputs
   


   init_LCD();  //inicjalizuj LCD, initiate of the LCD
   send_lcd_data(' ');
   init_LCD();

   send_lcd_reg(0x8F);   //ustaw: linia 1, pozyczja 16 (poza wyswietlaczem); set:linie 1, position 16 (beyond LCD)
   znak=0;
   do{
    send_lcd_data(text[znak]);       //wyslij zawartosc tablicy text[] do pamieci LCD, send the contents of the array text[] to LCD memeory
    znak++;
   }while(znak!=10);

   send_lcd_reg(0x80+0x40+15); 		//ustaw: linia 2, pozycja 15 (poza wyswietlaczem); set:line 2, position 15 (beyond LCD)
   znak=0;
    do{
    send_lcd_data(text2[znak]);       //wyslij zawartosc tablicy text2[], display the contents of the array text2[]
    znak++;
   }while(znak!=11);

   while(1)		//nieskoczona petla; 	infinite loop
   {
    send_lcd_reg(0x18);	//zmieniaj polozenie napisu, change a position of characters
    
	licznik=0;
	while(licznik<=14)
	{
	licznik++;
	delay(300000);
	}
	
	}
  }

  void send_lcd_data(unsigned char data_lcd)		//funkcja wywania danych do LCD; LCD data sending function
  {
    PORTD = ((data_lcd >> 2)& 0xfc) | 0x01;    //RS=1, E=0
    //delay(200);
    PORTD = ((data_lcd >> 2)& 0xfc) | 0x03;    //RS=1, E=1
    //delay(200);
    PORTD = ((data_lcd >> 2)& 0xfc) | 0x01;    //RS=1, E=0
    //delay(200);

    PORTD = ((data_lcd << 2)& 0xFC) | 0x01;    //RS=1, E=0
    //delay(200);
    PORTD = ((data_lcd << 2)& 0xfc) | 0x03;    //RS=1, E=1
    //delay(200);
    PORTD = ((data_lcd << 2)& 0xfc) | 0x01;    //RS=1, E=0
    delay(1000);
   }

 void send_lcd_reg(unsigned char data_lcd)		//funkcja wywania komend do LCD; LCD command sending function
  {
    PORTD = ((data_lcd >> 2) & 0xFC);    //RS=0, E=0
    //delay(200);
    PORTD = ((data_lcd >> 2) & 0xFC)| 0x02;    //RS=0, E=1
    //delay(200);
    PORTD = ((data_lcd >> 2) & 0xFC);    //RS=0, E=0
    //delay(200);

    PORTD = ((data_lcd << 2) & 0xFC);    //RS=0, E=0
    //delay(200);
    PORTD = ((data_lcd << 2) & 0xFC) | 0x02;    //RS=0, E=1
    //delay(200);
    PORTD = ((data_lcd << 2) & 0xFC);    //RS=0, E=0
    delay(10000);
   }


 void delay(volatile unsigned int d)
	{
    _delay_loop_2(d);
	}


  void init_LCD(void)			//funkcja inicjacji LCD; LCD initiate function
  {
   delay(30000);
   delay(30000);
  //send_lcd_reg(0x28);			//2 linie, 4 bity  ,2 lines, 4 bits
   //delay(100);
   send_lcd_reg(0x28);
   delay(1000);
   send_lcd_reg(0x0C);			//wlacz LCD, wlacz kursor; LCD on, cursor on
   delay(10000);
   send_lcd_reg(0x06);			///przesuwanie kursora w prawo; cursor inc.,
   delay(10000);
   send_lcd_reg(0x01);			//wyczysc LCD; clr LCD
   delay(100000);
   send_lcd_reg(0x02);			//cursor home,
   //delay(30000);
   delay(30000);
  }

